#include "smartcard.h"

unsigned char Control=0x0C;
unsigned char Data=0xF8;

// Initialise le lecteur de cartes

void InitCardReader()
{
  if (ioperm(LPT1Adr,3,1)!=0)
  {
    printf ("Vous n'avez pas les droits pour acceder aux ports");
    exit(0);
  }
  outb (Data,LPT1Adr);
  outb (Control,LPT1Adr+2);
  GreenLed(0);
  RedLed(0);
}
 
// Commande la led rouge

void GreenLed(unsigned char Status)
{
  if (Status==0) Control|=0x04; else Control&=0xFB;
  outb (Control,LPT1Adr+2);
    
}

// Commande la led verte

void RedLed(unsigned char Status)
{ 
  if (Status==0) Control&=0xF7; else    Control|=0x08;
  outb (Control,LPT1Adr+2);
}

// Renvoie 1 si une carte est présente dans le lecteur

unsigned char IsCard ()
{
  if ((inb(LPT1Adr+1) & 0x80) ==0) return (0);
  else return (1);
}

void Reset (unsigned char Status)
{
  if (Status==0) Data&=0xFE; else Data|=0x01;   
  outb (Data,LPT1Adr);
}

unsigned char IO ()
{
  if ((inb(LPT1Adr+1) & 0x40) ==0) return (0);
  else return (1);
}

void Clk (unsigned char Status)
{
  if (Status==0) Data&=0xFD; else Data|=0x02;   
  outb (Data,LPT1Adr);
}

void RAZ()
{
  Clk (0);
  Reset (0);
  Next();
  Reset (1);
  usleep(Tempo);
}

void Next()
{
  Clk (0);
  usleep(Tempo);
  Clk (1);
  usleep(Tempo);
  Clk (0);
  usleep(Tempo);
}
